'5-punktowy korektor graficzny
'Copyright Robert Wogajew 2009
'10.11.2009
$regfile = "m8def.dat"       'Deklaracja typu uywanego mikrokontrolera
$crystal = 8000000       'Deklaracja czstotliwoci zegara taktujcego procesor- musi byc zgodna z Fuse-bits
$hwstack = 36       'Deklaracja rozmiaru stosu sprztowego
$swstack = 32       'Deklaracja rozmiaru stosu programowego
$framesize = 40       'Deklaracja rozmiaru obszaru tzw.ramki

Config Int0 = Falling       'Konfiguracja sposobu wyzwalania przerwania zewn. INT0 - opadajcym zboczem
On Int0 Check_encoder       'Deklaracja procedury obsugi przerwania INT0 - obsugujcego enkoder
Enable Int0       'Wczenie obsugi przerwania INT0
Enable Interrupts

'Konfiguracja podczenia oraz typu wywietlacza LCD - kierunki portw danych ustawi kompilator
Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portb.3 , Db5 = Portb.2 , Db6 = Portb.1 , Db7 = Portb.0 , E = Portb.4 , Rs = Portb.5

'Konfiguracja portw I/O
Ddrc = &B11111111       'Nieuywane porty jako porty wyjciowe z aktywnym stanem "0"
Ddrd = &B11000011       'PD5..PD2 jako porty wejciowe do obsugi enkodera, jego przycisku i przycisku Memory
Portd = &B00111100

'Deklaracja zmiennych
Dim Value As Byte       'Wskanik regulowanej wartoci
Dim Refresh As Bit       'Flaga dania odwierzenia ekranu
Dim Send As Bit       'Flaga dania wysania danych do TDA7317

Dim Bands(6) As Byte       'Wartoci ustawie dla poszczeglnych pasm korektora (1..5) + gono (6)

Dim Btemp1 As Byte , Btemp2 As Byte       'Zmienne tymczasowe typu Byte

'###################################################################################
'Deklaracja uywanych procedur
Declare Sub Initialize
Declare Sub Redraw
Declare Sub Send_data

'Aliasy przyciskw
Set_switch Alias Pind.4
Memory_switch Alias Pind.5
'###################################################################################
'###################################################################################

Call Initialize

Do

 'Sprawdzamy czy nie nacinito oki enkodera, ktra suy do zmiany regulowanej wartoci. Sama regulacja przeprowadzana jest na skutek
 'krcenia osi enkodera, ktrej to obsuga realizowana jest w procedurze obsugi przerwania Int0
 If Set_switch = 0 Then
   Waitms 25
   If Set_switch = 0 Then
      'O enkodera zostaa nacinita - zmieniamy regulowan warto i aktualizujemy zawarto ekranu
      Incr Value
      If Value > 6 Then Value = 1       'Zawenie dopuszczalnych wartoci do zakresu 1..6
      Set Refresh       'Ustawiamy flag dania odwierzenia ekranu
      Waitms 25
   End If
 End If

 'Sprawdzamy czy nie nacinito przycisku pamici, ktry suy do zapisu nastaw korektora w pamici EEPROM
 If Memory_switch = 0 Then
   Waitms 25
   If Memory_switch = 0 Then
     'Zapisujemy wszystkie nastawy korektora w pamici EEPROM
      For Btemp1 = 1 To 6
        Writeeeprom Bands(btemp1) , Btemp1
      Next Btemp1
   End If
 End If

 'Wysanie danych do ukadw TDA inicjowane ustawieniem flagi Send - w procedurze obsugi przerwania Int0
 If Send = 1 Then
    Call Send_data       'Aktualizujemy nastawy ukadu TDA7317 w zalenoci wskanika regulowanej wartoci (zmienna Value)
    Reset Send
 End If

 'Odwierzenie zawartoci ekranu inicjowane ustawieniem flagi Refresh - w procedurze obsugi przerwania Int0 lub na skutek nacinicia
 'oki enkodera sucej do zmiany regulowanej wartoci (przycisk Set_switch)
 If Refresh = 1 Then
    Call Redraw       'Aktualizujemy zawarto ekranu
    Reset Refresh
 End If

Loop

'###################################################################################
'###################################################################################

Sub Initialize
 Cls
 'Definiujemy cakowicie wypeniony segment, gdy nie zawsze musi wystpowa w specyfikacji danego wywietlacza
 Deflcdchar 0 , 31 , 31 , 31 , 31 , 31 , 31 , 31 , 31
 Cls
 Cursor Off Noblink
 'Konfiguracja interfejsu TWI - ustawiamy czstotliwo magistrali na 100kHz
 Twbr = 32
 Twsr.twps1 = 0
 Twsr.twps0 = 0

 'Odczytujemy wartoci regulacyjne zapisane w EEPROMie i jednoczenie wysyamy je do ukadu TDA7317
 For Value = 1 To 5
   Readeeprom Bands(value) , Value
   'Jednoczenie sprawdzamy odczytane wartoci i poprawiamy je w przypadku, gdyby wyszy poza zakres
   If Bands(value) > 14 Then Bands(value) = 7       '0dB
   Call Send_data       'Wysyamy odczytan warto
   Waitus 200
 Next Value

 'To samo wykonujemy dla gonoci
 Value = 6
 Readeeprom Bands(6) , 6
 'Teraz sprawdzamy odczytan wartoci i poprawiamy j w przypadku, gdyby wysza poza zakres
 If Bands(6) > 47 Then Bands(6) = 0       '-17.625dB
 Call Send_data       'Wysyamy odczytan warto

 Set Refresh       'Pierwsze pokazanie zawartoci ekranu - zaczynamy od gonoci
End Sub

'###################################################################################

Sub Redraw
 'Pokazujemy zawarto ekranu

 If Value <> 6 Then
   'Dla pasm regulacyjnych korektora

   Home Upper
   Select Case Value
     Case 1 : Lcd "[62 Hz]         "
     Case 2 : Lcd "[250 Hz]        "
     Case 3 : Lcd "[1 kHz]         "
     Case 4 : Lcd "[4 kHz]         "
     Case 5 : Lcd "[10 kHz]        "
   End Select

   Home Lower
   'Wywietlamy pasek reprezentujcy ustawienia wzmocnienia/tumienia w wybranym pamie regulacji
   Select Case Bands(value)

     Case Is < 7 :

                         For Btemp1 = 1 To Bands(value)
                            Lcd Chr(32)       'Wywietlamy "puste" pola
                         Next Btemp1

                         Btemp1 = 7 - Bands(value)       'Zakres: 7...1
                         For Btemp2 = 1 To Btemp1
                            Lcd Chr(0)       'Wywietlamy pasek tumienia
                         Next Btemp2

                         Lcd Chr(0) ; "        "       'Cz ekranu pokazujca wzmocnienie

     Case 7 :
                         Lcd "       " ; Chr(0) ; "        "

     Case Is > 7 :
                         Lcd "       " ; Chr(0)       'Cz ekranu pokazujca tumienie

                         Btemp1 = Bands(value) - 7       'Zakres: 1...7
                         For Btemp2 = 1 To Btemp1
                            Lcd Chr(0)       'Wywietlamy pasek wzmocnienia
                         Next Btemp2

                         Btemp1 = 7 - Btemp1       'Zakres: 6...0
                         For Btemp2 = 1 To Btemp1
                            Lcd Chr(32)       'Wywietlamy "puste" pola
                         Next Btemp2

                         Lcd Chr(32)       'Ostatni, niewykorzystany znak

   End Select

 Else
   'Dla regulacji gonoci

   Home Upper
   Lcd "[Volume]        "
   Home Lower
   Btemp1 = Bands(6) \ 3       'Obliczamy liczb segmentw reprezentujc poziom gonoci (przy obliczeniach pomijamy ostatni znak nr 16)
   For Btemp2 = 1 To Btemp1
     Lcd Chr(0)       'Wywietlamy pasek gonoci
   Next Btemp2

   Btemp1 = 15 - Btemp1       'Obliczamy liczb "pustych" segmentw
   For Btemp2 = 1 To Btemp1
     Lcd Chr(32)       'Wywietlamy "puste" pola
   Next Btemp2

   Lcd Chr(32)       'Ostatni, niewykorzystany znak
 End If

End Sub

'###################################################################################
'Procedura wysyajca dane do ukadu TDA7317. Wskanik waciwej wielkoci przeznaczonej do wysania przechowuje zmienna Value za sam
'warto zmienna tablicowa Bands(Value). Value= 1..5 to ustawienia wzmocnienia/tumienia dla kolejnych pasm korektora. Value=6 to wskanik
'wartoci dla regulacji gonoci. Wartoci wzmocnienia/tumienia pasm regulacyjnych w zalenoci od wartoci zmiennej Band dobrano nastpujco:
'Bands(Value)= 0 to -14dB, Bands(Value)=1 to -12dB......Bands(Value)=7 to 0dB, Bands(Value)=8 to +2dB......Bands(Value)=14 to +14dB
'Dla regulacji gonoci jest to odpowiednio: Bands(6)=0 to -17.625dB a warto maksymalna Bands(6)=47 to 0dB

Sub Send_data

 'W zalenoci od wartoci parametru Value, ktry reprezentuje numer pasma regulacyjnego w programie uytkownika
 'obliczamy rzeczywsit warto bitw D3, D2, D1 ktre to reprezentuj w/w ustawienia wedug specyfikacji ukadu TDA7317
 'Dla regulacji gonoci przyjmujemy "0", gdy nie ma to w tej chwili znaczenia
 Select Case Value
    Case 1 : Btemp1 = 4       'pasmo 62 Hz
    Case 2 : Btemp1 = 1       'pasmo 250 Hz
    Case 3 : Btemp1 = 2       'pasmo 1 kHz
    Case 4 : Btemp1 = 3       'pasmo 4 kHz
    Case 5 : Btemp1 = 0       'pasmo 10 kHz
    Case 6 : Btemp1 = 0       'Regulacja gonoci
 End Select

 'Teraz wyznaczamy rzeczywist warto jak naley przesa do ukadu TDA7317 w odpowiedzi na warto umieszczon w zmiennej Bands(Value)
 'Dla regulacji wzmocnienia/tumienia pasm regulacyjnych stosujemy ponisze przeliczenia
 Select Case Bands(value)
    Case Is < 7 : Btemp2 = 15 - Bands(value)
    Case 7 : Btemp2 = 0
    Case Is > 7 : Btemp2 = Bands(value) - 7
 End Select

 'Dla regulacji gonoci zastosowa trzeba inny sposb przeliczania - wynika to oczywicie z dokumentacji ukadu TDA7317
 If Value = 6 Then Btemp2 = Bands(6)

 'Teraz obliczamy sumaryczn warto bajtu jaki trzeba wysa aby uwzgldni wybrane pasmo regulacji oraz dan warto wzmocnienia/tumienia
 'dla tego pasma czy te warto dla regulacji gonoci
 Shift Btemp1 , Left , 4
 Btemp1 = Btemp1 Or Btemp2
 'W przypadku regulacji wzmocnienia/tumienia dla pasm regulacyjnych korektora ustawiamy bit MSB - wynika to z dokumentacji ukadu TDA7317
 If Value <> 6 Then Set Btemp1.7

 'W kocu wysyamy kompletny bajt regulacyjny

  'Wysyamy sygna Start
  Twcr = &B10100100       'Ustawiony TWINT, TWSTA, TWEN
  Bitwait Twcr.twint , Set       'Czekamy, a interfejs TWI wykona Start i zgosi to ustawiajc flag TWINT

  'Wysyamy adres ukadu TDA7317 w konfiguracji z wyprowadzeniam ADDR podczonym do masy
  Twdr = &B10000100       'Adres
  Twcr = &B10000100       'Ustawiony TWINT, skasowany TWSTA i ustawiony TWEN - i inicjujemy jego wysanie
  Bitwait Twcr.twint , Set       'Czekamy, a interfejs TWI wyle Adres i zgosi to ustawiajc flag TWINT

  'Wysyamy wyznaczony wczeniej bajt regulacyjny
  Twdr = Btemp1
  Twcr = &B10000100       'Ustawiony TWINT, skasowany TWSTA i ustawiony TWEN - i inicjujemy jego wysanie
  Bitwait Twcr.twint , Set       'Czekamy, a interfejs TWI wyle Adres i zgosi to ustawiajc flag TWINT

  'Inicjujemy wysanie sygnau Stop
  Twcr = &B10010100       'Ustawiony TWINT, TWSTO i TWEN
  'I NIE czekamy na nic bo po Stop-ie nie jest ustawiana flaga TWINT

End Sub
'###################################################################################
'###################################################################################

'Przerwanie INT0 - odpowiedzialne za obsug enkodera jako elementu regulacyjnego - o tym, ktr zmienn naley podda regulacji
'decyduje wskanik Value. Przerwanie wywoywane jest opadajcym zboczem na porcie PIND.3 poczonym z jednym z wyprowadze enkodera
Check_encoder:

 If Pind.3 = 0 Then
    'ZWIKSZAMY WARTOCI

    If Value < 6 Then
        'Regulujemy wzmocnienie/tumienie w wybranym pamie regulacji
        If Bands(value) < 14 Then
           Incr Bands(value)
           Set Refresh       'Ustawiamy flag dania odwierzenia ekranu
           Set Send       'Ustawiamy flag dania wysania danych do TDA7317
        End If
     Else
        'Regulujemy gono
        If Bands(6) < 47 Then
           Incr Bands(6)
           Set Refresh       'Ustawiamy flag dania odwierzenia ekranu
           Set Send       'Ustawiamy flag dania wysania danych do TDA7317
        End If
     End If

 Else
    'ZMNIEJSZAMY WARTOCI

    If Value < 6 Then
        'Regulujemy wzmocnienie/tumienie w wybranym pamie regulacji
        If Bands(value) <> 0 Then
           Decr Bands(value)
           Set Refresh       'Ustawiamy flag dania odwierzenia ekranu
           Set Send       'Ustawiamy flag dania wysania danych do TDA7317
        End If
     Else
        'Regulujemy gono
        If Bands(6) <> 0 Then
           Decr Bands(6)
           Set Refresh       'Ustawiamy flag dania odwierzenia ekranu
           Set Send       'Ustawiamy flag dania wysania danych do TDA7317
        End If
     End If

 End If

Return