'Wywietlacz LCD z interfejsem I2C
'Copyright Robert Wogajew 2009
'15.11.2009
$regfile = "m8def.dat"       'Deklaracja typu uywanego mikrokontrolera
$crystal = 8000000       'Deklaracja czstotliwoci zegara taktujcego procesor- musi byc zgodna z Fuse-bits
$hwstack = 36       'Deklaracja rozmiaru stosu sprztowego
$swstack = 24       'Deklaracja rozmiaru stosu programowego
$framesize = 40       'Deklaracja rozmiaru obszaru tzw.ramki

'Deklaracja procedury obsugi przerwania od ukadu TWI
On Twi I2c_checking
'Wczenie globalnego zezwolenia na obsug przerwa systemowych
Enable Interrupts

'Konfiguracja podczenia oraz typu wywietlacza LCD - kierunki portw danych ustawi kompilator
Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0 , E = Portb.5 , Rs = Portb.4

'Konfiguracja ukadu Timer1 jako 2-kanaowego, 8-bitowego generatora PWM (f=1.96 kHz)
Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Up , Prescale = 8

'Konfiguracja portw I/O
Set Ddrb.1       'Wyjcie pierwszego kanau PWM ukadu Timer1 -> OC1A
Set Ddrb.2       'Wyjcie drugiego kanau PWM ukadu Timer1 -> OC1B

'Podcignicie rezystorw do wej adresowych A0, A1 i A2
Set Portd.0
Set Portd.1
Set Portd.2

'Reszta, nieuywanych portw jako porty wyjciowe z aktywnym stanem "0"
Ddrd = &B11111000
Set Ddrb.0
Set Ddrb.3

'###################################################################################

Dim Status As Byte       ' Status operacji na magistrali odczytywany w przerwaniu od ukadu TWI
Dim Index As Byte       'Wskanik liczby odebranych danych dla procedury obsugi przerwania od ukadu TWI
Dim Refresh As Bit       'Flaga dania wysania danych do LCD - ustawiana w przerwaniu od ukadu TWI
'Tablica danych odbieranych w procedurze obsugi przerwania od ukadu TWI, w tym pierwszy bajt zawierajcy rozkaz
Dim Dane(41) As Byte

Dim Kontrast As Byte       'Zmienna przechowujca warto kontrastu wywietlacza LCD
Dim Podswietlenie As Byte       'Zmienna przechowujca warto jasnoci podwietlenia wywietlacza LCD
Dim Btemp As Byte       'Zmienna tymczasowa typu Byte
'###################################################################################

Declare Sub Programerror
Declare Sub Initialize
'###################################################################################
'###################################################################################

Call Initialize       'Inicjalizacja sterownika

Do

 If Refresh = 1 Then
   'Zakoczono transmisj danych po magistrali I2C wic aktualizujemy zawarto LCD w zalenoci od przesanego rozkazu,
   'ktry znajduje si w bajcie Dane(1)
   'W pierwszej kolejnoci dezaktywujemy interfejs TWI aby nie odbiera kolejnych danych do czasu wywietlenia biecych
   Twcr.twen = 0

   'Jeli zmienna Wskanik=0 to znaczy, i wysano wycznie adres naszego ukadu a nastpnie sygna I2C Stop bez adnych,
   'dodatkowych danych co jest niedopuszczalne w zwizku z czym generujemy programowy bd (dla dalszej czci kodu)
   If Index = 0 Then Dane(1) = 111
   'Bd taki zostanie rwnie wygenerowany jeli urzdzenie nadrzdne wyle nieznany numer rozkazu lub niewystarczajc
   'liczb danych niezbdnych dla wykonania wybranego rozkazu

   'Dekodujemy przesane dane w zalenoci od rozkazu (bajt Dane(1)) i towarzyszcych mu bajtw danych
   Select Case Dane(1)

     Case &H00:       'Rozkaz: Wywietl znaki

                       If Index < 2 Then       'Sprawdzamy czy rozkaz zawiera odpowiedni, towarzyszca mu liczb bajtw danych
                         Call Programerror
                       Else
                         For Btemp = 2 To Index
                           Lcd Chr(dane(btemp))
                         Next Btemp
                       End If

     Case &H01:       'Rozkaz: Wyczy ekran

                       Cls

     Case &H02:       'Rozkaz: Ustaw parametry ekranu

                       If Index <> 2 Then       'Sprawdzamy czy rozkaz zawiera odpowiedni, towarzyszca mu liczb bajtw danych
                         Call Programerror
                       Else
                         'Uyjemy wewntrznej zmiennej jzyka Bascom, dziki ktrej kod rozkazu dla wywietlacza LCD zostanie zaadowany do rejestru R24
                         _temp1 = &B00001000 Or Dane(2)
                         $asm
                           Rcall _Lcd_control       'Przesyamu rozkaz zmiany parametrw ekranu do wywietlacza LCD korzystajc z wdudowanej procedury
                         $end Asm
                       End If

     Case &H03:       'Rozkaz: Parkuj kursor

                       If Index <> 2 Then       'Sprawdzamy czy rozkaz zawiera odpowiedni, towarzyszca mu liczb bajtw danych
                         Call Programerror
                       Else
                         If Dane(2) = 1 Then Home Lower Else Home Upper
                       End If

     Case &H04:       'Rozkaz: Przestaw kursor

                       If Index <> 3 Then       'Sprawdzamy czy rozkaz zawiera odpowiedni, towarzyszca mu liczb bajtw danych
                         Call Programerror
                       Else
                         Locate Dane(2) , Dane(3)
                       End If

     Case &H05:       'Rozkaz: Przesu kursor

                       If Index <> 2 Then       'Sprawdzamy czy rozkaz zawiera odpowiedni, towarzyszca mu liczb bajtw danych
                         Call Programerror
                       Else
                         If Dane(2) = 0 Then Shiftcursor Left Else Shiftcursor Right
                       End If

     Case &H06:       'Rozkaz: Przesu zawarto ekranu

                       If Index <> 2 Then       'Sprawdzamy czy rozkaz zawiera odpowiedni, towarzyszca mu liczb bajtw danych
                         Call Programerror
                       Else
                         If Dane(2) = 0 Then Shiftlcd Left Else Shiftlcd Right
                       End If

    'Rozkazy specjalne

     Case &H64:       'Rozkaz: Ustaw kontrast wywietlacza

                       If Index <> 2 Then       'Sprawdzamy czy rozkaz zawiera odpowiedni, towarzyszca mu liczb bajtw danych
                         Call Programerror
                       Else
                         Kontrast = Dane(2)
                         Pwm1a = Kontrast
                         Writeeeprom Kontrast , 2
                       End If

    Case &H65:       'Rozkaz: Ustaw jasno podwietlenia wywietlacza

                       If Index <> 2 Then       'Sprawdzamy czy rozkaz zawiera odpowiedni, towarzyszca mu liczb bajtw danych
                         Call Programerror
                       Else
                         Podswietlenie = Dane(2)
                         Pwm1b = Podswietlenie
                         Writeeeprom Podswietlenie , 3
                       End If

    Case &H66:       'Rozkaz: Wycz podwietlenie wywietlacza - stopniowo

                       For Btemp = Podswietlenie To 0 Step -1
                         Pwm1b = Btemp
                         Waitus 800
                       Next Btemp

    Case &H67:       'Rozkaz: Wcz podwietlenie wywietlacza - stopniowo

                       For Btemp = 0 To Podswietlenie
                         Pwm1b = Btemp
                         Waitus 800
                       Next Btemp

    Case Else :       'Pozostae, nieobsugiwane rozkazy jak i bd programowy (111)

                       Call Programerror

   End Select

   Index = 0       'Zerujemy wskaznik liczby odebranych danych
   Reset Refresh       'Czycimy flag dania wysania danych do LCD
   Twcr.twen = 1       'Aktywujemy interfejs TWI

 End If

Loop
'###################################################################################
'###################################################################################

Sub Programerror
 Cls
 Lcd "Transmit error."
End Sub

'###################################################################################

Sub Initialize
 'Ustalamy adres sterownika na magistrali I2C nie pozwalajc jednoczenie na obsug trybu General Call (Bit0=0)
 'Wspomniany adres ustawiany jest za pomoc dip-switch'y na porcie PD0..PD2. Przewidziano 8 wariantw adresu
 'z zakresu: 128..142 (dziesitnie, tylko wartoci parzyste)
 Btemp = Pind And &B00000111
 Shift Btemp , Left , 1
 Set Btemp.7
 Twar = Btemp       'Wpisanie wyznaczonego adresu do rejestru adresu interfejsu TWI mikrokontrolera
 'Uruchomienie interfejsu TWI
 'Bit 6 uruchamia sygna potwierdzenia ACK, Bit 2 uruchamia interfejs TWI, Bit 0 uruchamia przerwanie od ukadu TWI
 Twcr = &B01000101

 'Zerowanie zmiennych
 Reset Refresh
 Index = 0

 'Czycimy ekran
 Cls
 'Definiujemy polskie mae znaki diakrytyczne
 Deflcdchar 0 , 0 , 14 , 1 , 15 , 17 , 15 , 2 , 0
 Deflcdchar 1 , 2 , 4 , 14 , 16 , 16 , 17 , 14 , 32
 Deflcdchar 2 , 0 , 14 , 17 , 31 , 16 , 14 , 2 , 0
 Deflcdchar 3 , 12 , 4 , 6 , 4 , 12 , 4 , 14 , 0
 Deflcdchar 4 , 2 , 4 , 22 , 25 , 17 , 17 , 17 , 0
 Deflcdchar 5 , 2 , 4 , 14 , 17 , 17 , 17 , 14 , 0
 Deflcdchar 6 , 2 , 4 , 14 , 16 , 14 , 1 , 30 , 0
 Deflcdchar 7 , 2 , 4 , 31 , 2 , 4 , 8 , 31 , 0
 Cls       'Aktualizujemy pami generator znakw

 Cursor Off Noblink       'Domylnie wyczamy kursor jak i jego miganie
 'Czytamy zapisane wartoci nastaw dla kontrastu i podwietlenia z wbudowanej pamici EEPROM
 Readeeprom Kontrast , 2
 Pwm1a = Kontrast       'Ustawiamy kontrast
 Readeeprom Podswietlenie , 3
 Pwm1b = Podswietlenie       'Ustawiamy jasno podwietlenia
End Sub

'###################################################################################
'###################################################################################

'Procedura obsugi przerwania od ukadu TWI - nie uwzgldnia bdnie skonstruowanych ramek transmisji
I2c_checking:

 'Odczytujemy status operacji na magistrali TWI (z rejestru TWSR) maskujc 3 ostatnie - niewane dla nas bity preskalera
 'W naszym przypadku, obsugiwane s nastpujce wartoci odczytanej zmiennej Status (wraz z ich interpretacj):
 '&H80: Poprzednio zaadresowany sterownik odebra bajt danych i potwierdzi go sygnaem ACK
 '&HA0: Odebrano sygna Stop lub "powtrzony" Start

 Status = Twsr And &B11111000

 If Status = &H80 Then
   'Zapeniamy tablic przesanych danych przy czym w komrce 1-szej znajdzie si bajt Rozkazu
   If Index < 41 Then
     'Do tablicy trafi mkasymalnie 41 danych, reszta zostanie pominita
     Incr Index
     Dane(index) = Twdr
   End If
 End If

 If Status = &HA0 Then
   'Ustawiamy flag dania wysania danych do LCD
   Set Refresh
 End If

 'Czycimy flag zgoszenia przerwania (wpisujc 1) aby umoliwi dalsze funkcjonowanie interfejsu TWI
 Twcr.twint = 1

Return