'Sterownik panela dotykowego
'Copyright Robert Wogajew 2009
'31.10.2009
$regfile = "m8def.dat"       'Deklaracja typu uywanego mikrokontrolera
$crystal = 8000000       'Deklaracja czstotliwoci zegara taktujcego procesor- musi byc zgodna z Fuse-bits
$hwstack = 32       'Deklaracja rozmiaru stosu sprztowego
$swstack = 32       'Deklaracja rozmiaru stosu programowego
$framesize = 40       'Deklaracja rozmiaru obszaru tzw.ramki

'Konfiguracja portw I/O. Wszystkie nieuywane porty jako porty wyjciowe z aktywnym stanem "0"
Set Portb.5       'Port penicy funkcj INT - zgoszenie przerwania do ukadu docelowego przy naciniciu panela
Ddrb = &B11111111
Ddrd = &B11111111

'Konfiguracja przetwornika ADC w trybie Single z napiciem odniesienia Uref=5V
Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc       'Uruchomienie przetwornika - nie jest konieczne - przetwornik uruchamiany jest instrukcj konfiguracyjn jw.

Dim Coordx As Word , Coordy As Word       'Zmienne koordynat X i Y miejsca nacinicia panela dotykowego
Dim X_value As Word , Y_value As Word       'Zmienne koordynat X i Y z punktu widzenia interfejsu TWI
Dim Ready As Bit       'Flaga nacinicia panela dotykowego

Dim Status As Byte       ' Status operacji na magistrali - odczytywany w procedurze obsugi przerwania TWI
Dim Index As Byte       'Indeks liczby wysanych danych - uywany w procedurze obsugi przerwania TWI

'Zmienne pomocnicze
Dim Cnt As Byte
Dim Diff As Integer

'Deklaracje nagwkw uywanych procedur
Declare Sub Initialize
Declare Sub Readpanel

'###################################################################################
'###################################################################################
Call Initialize

Do
  Call Readpanel
  'Jeli zmienna Ready=1 to znaczy, i nacinito panel dotykowy. Naley w takim razie zgosi do ukadu docelowego powyszy fakt
  'poprzez cignicie wyprowadzenia INT do logicznego "0"
  Portb.5 = Not Ready
Loop
'###################################################################################
'###################################################################################

Sub Initialize
  'Ustawiamy adres sprztowy naszego ukadu Slave
  'Wynikowy adres po stronie ukadu Master to &B01010101, gdy Master ustawi nasz ukad w tryb odczytu
  Twar = &B01010100
  'Uruchomienie interfejsu TWI
  'Bit 6 uruchamia sygna potwierdzenia ACK, Bit 2 uruchamia interfejs TWI, Bit 0 uruchamia przerwanie od ukadu TWI
  Twcr = &B01000101
  'Ustawiamy wartoci startowe zmiennych koordynat widzianych z poziomu interfejsu TWI
  X_value = 0
  Y_value = 0
  'Deklaracja procedury obsugi przerwania od ukadu TWI
  On Twi I2c_checking
  'Wczenie zezwolenia na obsug przerwa systemowych
  Enable Interrupts
End Sub

'###################################################################################

Sub Readpanel

  Reset Ready       'Wyczyszczenie flagi nacinicia panela

  Set Portc.3
  Set Ddrc.3       'Kocwka mikrokontrolera podczona do Y2 = 5V
  Set Ddrc.0       'Kocwka mikrokontrolera podczona do X1 = 0V
  Waitms 1

  Coordx = Getadc(1)       'Odczyt parametru Z2
  Coordy = Getadc(2)       'Odczyt parametru Z1
  Incr Coordy
  Coordx = Coordx \ Coordy       'Obliczenie Z2\(Z1+1)

  If Coordx < 10 Then       'Sprawdzenie, czy sia nacisku na panel jest prawidowa - RTmax=10

    Reset Ddrc.0       'Kocwka mikrokontrolera podczona do X1 jako wejcie
    Set Portc.0       'Podcignicie X1 do 5V - zapewnia lepsz stabilno pomiarw
    Set Ddrc.1       'Kocwka mikrokontrolera podczona do Y1 = 0V
    Waitms 1

    Coordy = Getadc(2)       'Odczyt zmiennej Yodn

    'Powtarzamy ten sam odczyt czterokrotnie by upewni si, i jest to stabilny odczyt - Ylimit=8
    For Cnt = 1 To 4
      Waitus 200
      Diff = Getadc(2)
      Diff = Diff - Coordy
      Diff = Abs(diff)

      Reset Ready
      If Diff < 8 Then Set Ready Else Exit For
    Next Cnt

    'Dalsz cz kodu wykonujemy niezalenie od stanu flagi Ready cho mona go sprawdza
    'i w przypadku gdy Ready=0 pomija jego wykonanie co skrci czas obsugi panela dotykowego
    'oraz zgodne bdzie z podan wczeniej procedur

    Reset Portc.3
    Reset Ddrc.3       'Kocwka mikrokontrolera podczona do Y2 jako wejcie
    Reset Ddrc.1       'Kocwka mikrokontrolera podczona do Y1 jako wejcie
    Set Portc.1       'Podcignicie Y1 do 5V - zapewnia lepsz stabilno pomiarw

    Reset Portc.0
    Set Ddrc.0       'Kocwka mikrokontrolera podczona do X1 = 0V
    Set Portc.2
    Set Ddrc.2       'Kocwka mikrokontrolera podczona do X2 = 5V
    Waitms 1

    Coordx = Getadc(3)       'Odczyt zmiennej Xodn

   'Powtarzamy ten odczyt 4 razy i sprawdzamy czy nie rni si zbyt wiele od poprzednich  - Xlimit=8
    For Cnt = 1 To 4
      Waitus 200
      Diff = Getadc(3)
      Diff = Diff - Coordx
      Diff = Abs(diff)

      Reset Ready
      If Diff < 8 Then Set Ready Else Exit For
    Next Cnt

    'Powrt parametrw portw do wartoci wyjciowych - jak po wczeniu zasilania
    Reset Portc.1
    Reset Portc.2
    Reset Ddrc.2
    Reset Ddrc.0

    'W przypadku, gdy odczyt jest poprawny (czyli Ready=1) przepisujemy wartoci koordynat do zmiennych
    'widocznych z poziomu magistrali TWI
    If Ready = 1 Then
       X_value = Coordx
       Y_value = Coordy
    End If

  End If       'Do warunku wykrycia odpowiedniej siy nacisku panela: if Coordx < 10

End Sub

'###################################################################################
'###################################################################################

'Procedura obsugi przerwania od ukadu TWI - nie uwzgldnia bdnie skonstruowanych ramek transmisji
I2c_checking:

  'Odczytujemy status operacji na magistrali TWI (z rejestru TWSR) maskujc 3 ostatnie - niewane dla nas bity preskalera
  'Status = &HA8 - Ukad Slave zosta wanie zaadresowany do odczytu i potwierdz to sygnaem potwierdzenia -> ACK
  'Status = &HB8 - Ukad Slave wysa dan do ukadu Master i odebra sygna potwierdzenia -> ACK
  'Status = &HC0 - Ukad Slave wysa ostatni dan do ukadu Master i nie odebra sygnau potwierdzenia -> NACK
  Status = Twsr And &B11111000

  Select Case Status

    Case &HA8:
                         'Ukad Slave zosta wanie zaadresowany do odczytu i potwierdz to sygnaem potwierdzenia -> ACK
                         'Wysyami pierwszy bajt danych - MSB ze zmiennej X_value
                         Twdr = High(x_value)
                         Index = 1       'Ustawiamy indeks wysanych danych


    Case &HB8:
                         'Ukad Slave wysa dan do ukadu Master i odebra sygna potwierdzenia -> ACK
                         'Wysyamy kolejne dane do ukadu Master czyli: LSB z X_value, MSB z Y_value i LSB z Y_value
                         Incr Index       'Zwikszamy index kolejno wysyanych danych

                         Select Case Index
                           Case 2 : Twdr = Low(x_value)
                           Case 3 : Twdr = High(y_value)
                           Case 4 :
                                         Twdr = Low(y_value)
                                         'Jako, e jest to ostatnia dana, ktra powinna by wysana do ukadu Master, kasujemy bit potwierdzenia
                                         'TWEA, gdy ukad Slave nie oczekuje ju potwierdzenia po stronie ukadu Master
                                         Reset Twcr.twea
                         End Select


    Case &HC0:
                         'Ukad Slave wysa ostatni dan do ukadu Master i nie odebra sygnau potwierdzenia jak oczekiwano -> NACK
                         'Tym samym przeszed w tryb pasywny co znaczy, e nie odpowiadaby na swj adres przy kolejnych
                         'adresowaniach wysyanych przez ukad Master. Aktywujemy go ponownie korzystajc z bitu potiwerdzenia TWEA.
                         Set Twcr.twea
                         'Kasujemy sprztow flag dania przerwania dla ukadu zewntrznego jako, e wszystkie dane zostay wysane
                         Set Portb.5
                         'Kasujemy zmienne koordynat widziane z poziomu interfejsu TWI, gdy zostay odczytane
                         X_value = 0
                         Y_value = 0
  End Select

  'Czycimy flag zgoszenia przerwania (wpisujc 1) aby umoliwi dalsze funkcjonowanie interfejsu TWI
  Twcr.twint = 1

Return