'Sterownik rolety okiennej na magistral RS485
'Copyright Robert Wogajew 2009
'04.11.2009
$regfile = "m8def.dat"       'Deklaracja typu uywanego mikrokontrolera
$crystal = 8000000       'Deklaracja czstotliwoci zegara taktujcego procesor- musi byc zgodna z Fuse-bits
$baud = 9600       'Deklaracja prdkoci transmisji interfejsu USART
$hwstack = 40       'Deklaracja rozmiaru stosu sprztowego
$swstack = 32       'Deklaracja rozmiaru stosu programowego
$framesize = 40       'Deklaracja rozmiaru obszaru tzw.ramki

'Deklaracja procedury obsugi przerwania od odebrania znaku interfejsem USART (URXC)
On Urxc Check_rs485
'Wczenie obsugi przerwania URXC
Enable Urxc
'Wczenie globalnego zezwolenia na obsug przerwa systemowych
Enable Interrupts

'Konfiguracja ukadu Timer1 jako generatora PWM uywanego dla mikkiego startu silnika  (pin 15 - OC1A)
Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Down , Compare B Pwm = Disconnect , Prescale = 8
Set Ddrb.1       'Ustawienie OCA1 jako wyjcie - domylnie bdzie na nim stan "0"

'###################################################################################
Dim Address As Byte       'Adres urzdzenia dla interfejsu RS485
Dim Rs_data(2) As Byte       'Dane odbierane za pomoc interfejsu USART
Dim Index As Byte       'Wskanik kolejnej danej
Dim Rs485 As Byte       'Zmienna uywana w procedurze przerwania URXC
Dim Started As Bit , Stopped As Bit       'Wskaniki pocztku i koca ramki transmisji

Dim Refresh As Byte       'Flaga dania operacji ruchu rolety

'Zmienna uywana do programowego odmierzania czasu mikkiego rozruchu (1s), czasu podcigania roletek (1s)
'jak i czasu bezwzgldnego wyczenia silnika napdowego (10s)
Dim Clock As Word
Dim Direction As Bit       'Bit kierunku wykorzystywany w procedurze obsugi przerwania URXC

'###################################################################################
Declare Sub Initialize
Declare Sub Turn_off
Declare Sub Reset_rx_data
'###################################################################################

Set Ddrb.2       'Port przekanika jako port wyjciowy - domylnie bdzie na nim stan "0"
Set Ddrb.4       'Port diody LED UP jako port wyjciowy - domylnie bdzie na nim stan "0"
Set Ddrb.5       'Port diody LED DOWN jako port wyjciowy- domylnie bdzie na nim stan "0"

'Podcignicie wej adresowych do plusa zasilania
Set Portc.0
Set Portc.1
Set Portc.2
Set Portc.3
Set Portc.4

'Nieuywane porty jako wyjcia ze stanem "0"
Set Ddrc.5
Set Ddrd.2
Set Ddrd.3
Set Ddrd.4
Set Ddrd.5
Set Ddrb.0
Set Ddrb.3

'Aliasy wykorzystywanych portw
Relay Alias Portb.2       'Sterowanie przekanikiem kierunku obrotw
Up_led Alias Portb.4       'Sterowanie diod LED UP
Down_led Alias Portb.5       'Sterowanie diod  LED DOWN

'###################################################################################

Call Initialize

Do
  'Sprawdzamy flag dania operacji ruchu rolety - ustawiana w procedurze URXC
  If Refresh <> 0 Then

     'Dla Refresh=1 i 3 -> przekanik zaczony - ruch w gr
     'Dla Refresh=2 i 4 -> przekanik wyczony - ruch w d
     Relay = Refresh.0

     'Zapalamy diod sygnalizujc kierunek - dwukolorowa dioda LED
     Reset Up_led
     Reset Down_led
     Up_led = Refresh.0
     Down_led = Not Refresh.0

     'Sterujemy mikkim rozruchem silnika  - dla zmiennej Clock = 0...255
     If Clock < 256 Then Pwm1a = Clock       'Sterujemy tranzystorem BUZ11 przy udziale PWM

     'Odstp czasu pomidzy krokami ragulacji zapewniajcy odpowiedni przedzia czasowy regulacji
     Waitms 4
     'Sterujemy programowym zegarem odmierzajcym liczb ptli aby utrzyma zadane czasy
     Incr Clock

     'Teraz dla funkcji 1 i 2 sprawdzamy czy nie upyn czas podsunicia rolety (1s) a jeli tak to wyczamy silnik.
     'Dla funkcji 3 i 4 odpowiednie wyczenie nastpi po upyniciu czasu wyczenia bezwarunkowego (max. 30s)
     'lub (w sytuacji normalnej) po zadziaaniu zabezpieczenia od przecienia silnika. Czasy dobrano empirycznie.
     If Refresh < 3 Then
         If Clock = 512 Then Call Turn_off       'Czas 1s dla mikkiego rozruchu + 1s dla funkcji podcignicia (1 i 2)
     Else
         If Clock > 7500 Then Call Turn_off       'Czas wyczenia bezwarunkowego (max. 30s)
     End If

     'Niezalenie od tego sprawdzamy zabezpieczenie przecieniowe silnika serwomechanizmu
     'Zaczynamy w poowie okresu mikkiego rozruchu. Jeli napicie na AIN0 jest wysze ni na AIN1 to komparator
     'ustawi "1" w rejestrze ACSR.ACO
     If Acsr.aco = 1 And Clock > 127 Then Call Turn_off

  End If

Loop

'###################################################################################
Sub Turn_off
  Pwm1a = 0
  Refresh = 0
  Clock = 0
  Reset Relay
  Reset Up_led
  Reset Down_led
End Sub
'###################################################################################
Sub Initialize
  'Odczytujemy adres ukadu dla magistrali RS485 - tylko w trakcie uruchamiania urzdzenia
  Address = Pinc And &B00011111
  Set Address.7       ' Domylnie ma bit 7-my ustawiony, gdy takie zaoenie przyjto dla bajtw danych, w tym przypadku adresu
  'Zerowanie zmiennych i deklaracja ustawie pocztkowych
  Call Turn_off
  Index = 0
  Reset Started
  Reset Stopped
End Sub
'###################################################################################
Sub Reset_rx_data
  Index = 0
  Reset Started
  Reset Stopped
End Sub
'###################################################################################
'###################################################################################
'###################################################################################

'Procedura obsugi przerwania od ukadu USART - przerwanie URXC - procedura sprawdza poprawno ramki danych
'Kompletna ramka danych powinna wyglda nastpujco: Start (01h), Adres (>7Fh), Rozkaz(>7Fh), Stop (04h)
'Adres przechowuje zmienna Rs_data(1) a rozkaz zmienna Rs_data(2)

Check_rs485:

  Rs485 = Udr       'Pobieramy jeden bajt z bufora wejciowego ukadu USART

  Select Case Rs485
    Case 1:
                  'Ustawiamy flag odebrania bajta danych sygnalizujcego pocztek ramki danych
                   If Started = 0 Then
                     Set Started
                   Else
                     'Bd ramki - resetujemy zmienne ramki transmisji
                     Call Reset_rx_data
                   End If
    Case 4:
                  'Ustawiamy flag odebrania bajta danych sygnalizujcego koniec ramki danych - pod warunkiem, e mamy komplet danych
                  If Index = 2 Then
                    Set Stopped
                  Else
                     'Bd ramki - resetujemy zmienne ramki transmisji
                     Call Reset_rx_data
                  End If

    Case Is > 127:
                  'Odebrano bajt bdcy dan - sprawdzamy fakt odpowiedniej liczby danych
                  If Started = 1 And Index < 2 Then
                     Incr Index
                     Rs_data(index) = Rs485
                  Else
                     'Bd ramki gdy przesyano kolejn dan a powinien by przesany znacznik koca ramki lub te
                     'przesano dan bez wczeniejszego znacznika pocztku ramki - resetujemy zmienne ramki transmisji
                     Call Reset_rx_data
                  End If

     Case Else:
                     'Dana spoza zakresu - resetujemy zmienne ramki transmisji
                     Call Reset_rx_data
  End Select

  'Teraz sprawdzamy czy odebrano ju kompletn ramk danych - znacznik ustawiany jest w poprzednim warunku
  If Stopped = 1 Then
     'W takim razie sprawdzamy czy adres dotyczy naszego ukadu oraz czy rozkaz obsugiwany jest przez nasz sterownik
     If Rs_data(1) = Address Then

        'Maskujemy nastarszy bit rozkazu sygnalizujcy jedynie, e jest to bajt danych a dokadnie rozkaz
        Reset Rs_data(2).7

        'Dekodujemy przesany rozkaz ustawiajc odpowiednie parametry dla ptli gwnej, w ktrej to nastpi jego wykonanie
        Select Case Rs_data(2)

            Case 0:
                                 Call Turn_off       'Natychmiastowe wyczenie silnika napdu rolety

            Case 1 To 4:
                                'Ustalamy dany kierunek obrotw silnika (mwi o tym rozkaz znajdujcy si w zmiennej Rs_data(2)
                                'i zachowujemy go w zmiennej Direction aby porwna z kierunkiem ewentualnego, biecego ruchu rolety
                                If Rs_data(2).0 <> 1 Then Set Direction Else Reset Direction

                                'Teraz sprawdzamy czy akurat nie jestemy wanie w trakcie wykonywania jakie funkcji i w zalenoci
                                'od biecego stanu pracy ukadu oraz danego rozkazu, modyfikujemy zmienn Clock
                                If Refresh <> 0 Then
                                    'Jeli silnik jest ju poza obszarem mikkiego startu to przeduamy czas realizacji biecej funkcji
                                    If Clock > 255 Then Clock = 255
                                    'Jeli jednak krci si aktualnie w przeciwnym kierunku ni wynikaoby to z rozkazu to zaczynamy od mikkiego startu
                                    If Refresh.0 = Direction Then Clock = 0
                                End If

                                Refresh = Rs_data(2)       'Odwierzenie flagi dania ruchu rolety - dla ptli gwnej

        End Select

     End If       ' Do :  Rs_data(1) = Address

     'Zerujemy zmienne ramki, gdy informacje w niej zawarte zostay ju wykorzystane
     Call Reset_rx_data

  End If       ' Do :   If Stopped = 1


Return