'2-kanaowy termostat
'Copyright Robert Wogajew 2009
'12.11.2009
$regfile = "m8def.dat"       'Deklaracja typu uywanego mikrokontrolera
$crystal = 8000000       'Deklaracja czstotliwoci zegara taktujcego procesor- musi byc zgodna z Fuse-bits
$hwstack = 32       'Deklaracja rozmiaru stosu sprztowego
$swstack = 24       'Deklaracja rozmiaru stosu programowego
$framesize = 40       'Deklaracja rozmiaru obszaru tzw.ramki

'Konfiguracja typu i podczenia wywietlacz LCD
Config Lcd = 16 * 1
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0

'Konfiguracja magistrali 1wire
Config 1wire = Portd.0

'Konfiguracja portw I/O
Ddrb = &B11111111       'PB.0 to REL1, PB.1 to REL2
Ddrd = &B11110001       'PD.0 to 1wire, PD1...PD3 to przyciski, reszta nieuywane
Portd = &B00001110       'Podcignicie rezystorw pod przyciski

Dim Device1_nr(8) As Byte       'Tablica adresu pierwszego ukadu DS1820
Dim Device2_nr(8) As Byte       'Tablica adresu drugiego ukadu DS1820
Dim Ds_data(9) As Byte       'Tablica danych odczytanych z ukadu DS1820

Dim Temps(2) As Byte       'Tablica obliczonych temperatur
Dim Thermosts(2) As Byte       'Tablica nastaw termostatw

Dim Refresh As Bit       'Zmienna odpowiedzialna za odwierzanie ekranu
Dim Work_mode As Byte       'Tryb pracy urzdzenia
Dim Btemp1 As Byte , Btemp2 As Byte , Btemp3 As Byte       'Zmienne tymczasowe

Dim Clock As Word       'Programowy zegar do odmierzania czasu konwersji rwnego 750ms

Declare Sub Initialize
Declare Sub Init_measure
Declare Sub Take_measure
Declare Sub 1werror(byval Number As Byte)

'Aliasy
Mode_key Alias Pind.1
Up_key Alias Pind.2
Down_key Alias Pind.3
Rel1 Alias Portb.0
Rel2 Alias Portb.1

'###############################################################################
'###############################################################################
Call Initialize

Do

  'Sterowanie zegarem procesu pomiarowego temperatury
  Incr Clock
  If Clock > 55000 Then       '55000 daje odstp okoo 750ms - warto dobrana empirycznie
    'Odczytanie wszystkich wartoci temperatur
    Call Take_measure
    Clock = 0
    If Work_mode.1 = 0 Then Set Refresh       'Odwierzenie ekranu po odczycie temperatur- wycznie dla trybw 0..1
    'Wysanie rozkazu przeprowadzenia nowej konwersji temperatury dla wszystkich ukadw DS1820
    Call Init_measure
  End If

  'Obsuga klawiatury
  If Mode_key = 0 Then
    Waitms 25
    If Mode_key = 0 Then
      Incr Work_mode
      Work_mode = Work_mode And &B00000011       'Zawenie dopuszczalnych wartoci do 0..3
      Set Refresh       'Odwierzenie ekranu
    End If
  End If

  If Up_key = 0 Then
    Waitms 25
    If Up_key = 0 Then
      'Tylko dla trybw pokazywania wartoci ustawie termostatw czyli tryb 2 i 3
      If Work_mode.1 <> 0 Then
        Btemp1 = Work_mode - 1
        If Thermosts(btemp1) < 50 Then       'Ograniczenie zakresu ustawie do 50'C dla odpowiedniego termostatu
          Incr Thermosts(btemp1)
          Set Refresh       'Odwierzenie ekranu
          Writeeeprom Thermosts(btemp1) , Btemp1       'Zapisanie wartoci do pamici EEPROM
        End If
      End If
    End If
  End If

  If Down_key = 0 Then
    Waitms 25
    If Down_key = 0 Then
      'Tylko dla trybw pokazywania wartoci ustawie termostatw czyli tryb 2 i 3
      If Work_mode.1 <> 0 Then
        Btemp1 = Work_mode - 1
        If Thermosts(btemp1) <> 0 Then       'Ograniczenie zakresu ustawie do 0'C dla odpowiedniego termostatu
          Decr Thermosts(btemp1)
          Set Refresh       'Odwierzenie ekranu
          Writeeeprom Thermosts(btemp1) , Btemp1       'Zapisanie wartoci do pamici EEPROM
        End If
      End If
    End If
  End If

  'Obsuga wywietlacza LCD w zalenoci od trybu pracy: 0..1 (pokazywanie mierzonych temperatur) czy 2..3 (pokazywanie nastaw termostatw)
  If Refresh = 1 Then
    Home Upper

    If Work_mode.1 = 0 Then
      'Tryb 0..1 - pokazywanie mierzonych temperatur
      Btemp1 = 49 + Work_mode       'Obliczenie kodu znaku do wywietlenia: numer termometru
      Btemp2 = Makebcd(temps(work_mode + 1))       'Zamiana formatu odpowiedniej temperatury na BCD by atwo wywietli zera nieznaczce
      Lcd Chr(116) ; Chr(btemp1) ; Chr(58) ; Bcd(btemp2) ; Chr(0)       'Tekst w przykadowej postaci: t1:25'C
    Else
      'Tryb 2..3 - pokazywanie nastaw termostatw
      Btemp1 = 1       'Symbol grzejnika (dla termostatu nr 1)
      If Work_mode.0 = 1 Then Btemp1 = 42       'Symbol nieki (dla termostatu nr 2)
      Btemp2 = Makebcd(thermosts(work_mode - 1))       'Zamiana formatu odpowiedniej nastawy termostatu na BCD by atwo wywietli zera nieznaczce
      Lcd Chr(91) ; Chr(btemp1) ; Chr(93) ; Bcd(btemp2) ; Chr(0)       'Tekst w przykadowej postaci: [*]25'C
    End If

    Reset Refresh
    'Odczekanie, a zostan puszczone wszystkie przyciski (jeli nadal byyby przycinite)
    Do
    Loop Until Mode_key = 1 And Up_key = 1 And Down_key = 1
  End If

  'W kocu obsuga obu termostatw: termostat1 to grzaka a termostat2 to klimatyzator (inne zaoenia dziaania)
  'Dla grzaki ustalamy histerez regulacji na -1.5/+1.0 'C
  Btemp1 = Temps(1) + 1
  If Btemp1 < Thermosts(1) Then Set Rel1       'Wczmy grzak (przekanik REL1) jeli temperatura spadnie 1.5'C poniej ustawionej
  If Temps(1) > Thermosts(1) Then Reset Rel1       'Wyczmy grzak (przekanik REL1) jeli temperatura wzronie 1'C powyej ustawionej

  'Dla klimatyzatora ustalamy histerez regulacji take na +1.0/-1.5 'C
  If Temps(2) > Thermosts(2) Then Set Rel2       'Wczmy klimatyzator (przekanik REL2) jeli temperatura wzronie 1'C powyej ustawionej
  Btemp1 = Temps(2) + 1
  If Btemp1 < Thermosts(2) Then Reset Rel2       'Wyczmy klimatyzator (przekanik REL2) jeli temperatura spadnie 1.5'C poniej ustawionej

Loop
'###############################################################################
'###############################################################################

Sub Initialize
 'Ustalamy numery seryjne podczonych termometrw przy czym nie zapisujemy ich nigdzie, gdy da to moliwo
 'bezproblemowej wymiany dowolnego z nich bez specjalnych procedur konfiguracyjnych
 Device1_nr(1) = 1wsearchfirst()       'Ustalamy numer seryjny pierwszego ukadu DS1820
 Device2_nr(1) = 1wsearchnext()       'Ustalamy numer seryjny drugiego ukadu DS1820
 'Sprawdzamy stan flagi Err, ktra byaby rwna "1" jeli nie zostayby podczone przynajmniej 2 ukady DS1820
 If Err = 1 Then Call 1werror(51)       'Generujemy bd nr 3

 'Pierwsza inicjacja pomiaru temperatury
 Call Init_measure

 'Wczytujemy z pamici EEPROM zapisane nastawy dla obu termostatw
 Readeeprom Thermosts(1) , 1
 Readeeprom Thermosts(2) , 2
 'Ograniczenie dla powyszych wartoci, gdyby dane zapisane w EEPROMie byy bdne
 If Thermosts(1) > 50 Then Thermosts(1) = 20
 If Thermosts(2) > 50 Then Thermosts(2) = 20
 'Inicjujemy zmienne
 Work_mode = 0
 Clock = 55000       ' Ustawiamy tak warto by w ptli gwnej od razu nastpio odczytanie zmierzonych temperatur
 Set Refresh       'Ustawiamy by nastpio pierwsze odwierzenie ekranu w ptli gwnej

 'Ekran powitalny
 Cls
 Deflcdchar 0 , 24 , 24 , 6 , 9 , 8 , 9 , 6 , 32       'Definicja symbolu stopnia Celcjusza cznie z liter C
 Deflcdchar 1 , 21 , 32 , 21 , 32 , 31 , 17 , 17 , 32       'Definicja piktogramu grzejnika
 Cls
 Cursor Off Noblink
 Lcd "Hello!"
 Waitms 700
End Sub

'###############################################################################

Sub Init_measure
 1wreset       'Reset magisrtali 1wire
 1wwrite &HCC       'Polecenie: Skip ROM
 1wwrite &H44       'Polecenie: Convert T skierowane do wszystkich ukadw DS1820
End Sub

'###############################################################################

Sub Take_measure

 For Btemp3 = 1 To 2
   'Odczyt pierwszego (dla Btemp3=1)  i drugiego (dla Btemp3=2) termometru
   Btemp1 = 0       'Wskanik liczby odczytw termometru DS1820
   Do
     Incr Btemp1
     1wreset       'Reset magisrtali 1wire
     1wwrite &H55       'Polecenie: Match ROM (wybranie konkretnego ukadu)
     If Btemp3 = 1 Then 1wwrite Device1_nr(1) , 8 Else 1wwrite Device2_nr(1) , 8       'Wysyamy numer odpowiedniego ukadu DS1820
     1wwrite &HBE       'Polecenie: Read Scratchpad (odczyt )
     Ds_data(1) = 1wread(9)       'Odczytanie 9-ciu bajtw danych z ukadu DS1820 (cay Scratchpad) cznie z sum CRC8

     'Teraz z pierwszych 8-miu bajtw tablicy liczymy wasn sum CRC8 aby przekona si czy transmisja bya poprawna
     Btemp2 = Crc8(ds_data(1) , 8)

     'Powtarzam odczyt wybranego ukadu dopki przesany CRC8 i obliczony bd takie same co potwierdzi poprawno
     'transmisji lub nie uda si tego wykona piciokrotnie - wtedy generujemy bd i wstrzymujemy prac urzdzenia
   Loop Until Btemp2 = Ds_data(9) Or Btemp1 > 5

   If Btemp1 > 5 Then
    Btemp3 = Btemp3 + 48
    Call 1werror(btemp3)       'Generujemy bd nr 1 lub 2 w zalenoci od termometru, ktrego on dotyczy
   End If

   'Jeli program si nie zatrzyma to znaczy, i poprawnie dokonano odczytu z ukadu DS wic obliczamy odczytan temperatur
   Temps(btemp3) = Ds_data(1)       ' To jest "Temperature LSB" ze Scratchpada ukadu DS1820
   Shift Temps(btemp3) , Right , 1       'Przesuwamy o jeden bit w prawo, gdy nie interesuje nas warto bitu "p stopnia"

   'Jeeli "Temperature MSB" umieszczony w Ds_data(2)=255 to znaczy, i zmierzono temperatur ujemn wic jako temteratur
   'obliczeniow przyjmujemy "0" gdy wartoci ujemne nie s wykorzystywane przez ten ukad automatyki
   If Ds_data(2) = 255 Then Temps(btemp3) = 0
 Next Btemp3

End Sub

'###############################################################################

Sub 1werror(byval Number As Byte)
 Cls
 Lcd "Err:" ; Chr(number) ; Chr(32)
 'Wyczamy przekaniki
 Reset Rel1
 Reset Rel2
 'Blokujemy dziaanie ukadu
 Do
 Loop
End Sub

'###############################################################################